namespace Kresleni2
{
    
    public partial class Form1 : Form
    {
        private AbstractShape? shape;
        private Pen currentPen;
        public Form1()
        {
            InitializeComponent();
            shape = null;
            pictureBox1.Image =  new Bitmap(pictureBox1.Width, pictureBox1.Height);
            clearPicture(pictureBox1);
        }

        private void clearPicture(PictureBox pictureBox1)
        {
            using(Graphics g = Graphics.FromImage(pictureBox1.Image))
            {
                g.Clear(Color.White);
            }
        }

        private void novyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            clearPicture(pictureBox1);
        }

        private void ulozitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if(saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                pictureBox1.Image.Save(saveFileDialog1.FileName);
            }
        }

        private void caraToolStripMenuItem_Click(object sender, EventArgs e)
        {
            shape = new Line();
        }

        private void obdelnikToolStripMenuItem_Click(object sender, EventArgs e)
        {
            shape = new Rectangle();
        }

        private void elipsaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            shape = new Ellipse();
        }

        private void konecToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            AddShape dialog = new AddShape();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                if (shape != null)
                {
                    shape.X = e.X;
                    shape.Y = e.Y;

                    shape.Width = dialog.ShapeWidth;
                    shape.Height = dialog.ShapeHeight;
                    currentPen = dialog.PenValue;
                    using (Graphics g = Graphics.FromImage(pictureBox1.Image))
                    {
                        shape.Draw(g, currentPen);
                    }
                    Refresh();
                }

            }
        }
    }
}